SoVRMLInline(3)

NAME
SoVRMLInline - The SoVRMLInline class is used to insert VRML files into a scene.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLInline.h>

Inherits SoNode.

  Public Types
enum BboxVisibility { NEVER, UNTIL_LOADED, ALWAYS }

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLInline (void)
void setFullURLName (const SbString &url)
const SbString & getFullURLName (void)
SoGroup * copyChildren (void) const
void requestURLData (void)
SbBool isURLDataRequested (void) const
SbBool isURLDataHere (void) const
void cancelURLDataRequest (void)
void setChildData (SoNode *urlData)
SoNode * getChildData (void) const
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void search (SoSearchAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * getChildren (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
static void setFetchURLCallBack (SoVRMLInlineFetchURLCB *f, void *closure)
static void setBoundingBoxVisibility (BboxVisibility b)
static BboxVisibility getBoundingBoxVisibility (void)
static void setBoundingBoxColor (SbColor &color)
static SbColor & getBoundingBoxColor (void)
static void setReadAsSoFile (SbBool enable)
static SbBool getReadAsSoFile (void)

  Public Attributes
SoSFVec3f bboxCenter
SoSFVec3f bboxSize
SoMFString url

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLInline ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLInline class is used to insert VRML files into a scene. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

Inline {
  exposedField MFString url        []
  field        SFVec3f  bboxCenter 0 0 0     # (-,)
  field        SFVec3f  bboxSize   -1 -1 -1  # (0,) or -1,-1,-1
}

The Inline node is a grouping node that reads its children data from a location in the World Wide Web. Exactly when its children are read and displayed is not defined (e.g. reading the children may be delayed until the Inline node's bounding box is visible to the viewer). The url field specifies the URL containing the children. An Inline node with an empty URL does nothing.

Each specified URL shall refer to a valid VRML file that contains a list of children nodes, prototypes, and routes at the top level as described in 4.6.5, Grouping and children nodes.

The results are undefined if the URL refers to a file that is not VRML or if the VRML file contains non-children nodes at the top level.

If multiple URLs are specified, the browser may display a URL of a lower preference VRML file while it is obtaining, or if it is unable to obtain, the higher preference VRML file. Details on the url field and preference order can be found in 4.5, VRML and the World Wide Web (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.5).

The results are undefined if the contents of the URL change after it has been loaded.

The bboxCenter and bboxSize fields specify a bounding box that encloses the Inline node's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. A default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and if needed shall be calculated by the browser. A description of the bboxCenter and bboxSize fields is in 4.6.4, Bounding boxes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.4).

Member Enumeration Documentation

  enum SoVRMLInline::BboxVisibility

Enumerator

NEVER
    SoSFVec3f SoVRMLInline::bboxCenter Center of bounding box.

SoSFVec3f SoVRMLInline::bboxSize Size of bounding box.

SoMFString SoVRMLInline::url The VRML file URL.

enum SoVRMLInline::BboxVisibility Used to enumerate bounding box visibility settings.

Never display bounding box.

UNTIL_LOADED
    Display bounding box until file is loaded.

ALWAYS
    Always display bounding box.

Constructor & Destructor Documentation

  SoVRMLInline::SoVRMLInline (void)
Constructor

  SoVRMLInline::~SoVRMLInline () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLInline::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLInline::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoVRMLInline::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLInline::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVRMLInline::initClass (void) [static]

  void SoVRMLInline::setFullURLName (const SbString & urlref)
Sets the full (non-relative) URL name.

  const SbString & SoVRMLInline::getFullURLName (void)
Returns the full URL name.

  SoGroup * SoVRMLInline::copyChildren (void) const
Returns a copy of the children.

  void SoVRMLInline::requestURLData (void)
Request URL data.

  SbBool SoVRMLInline::isURLDataRequested (void) const
Returns TRUE if the URL data have been requested.

  SbBool SoVRMLInline::isURLDataHere (void) const
Returns TRUE if the data have been loaded.

  void SoVRMLInline::cancelURLDataRequest (void)
Cancel the URL data request.

  void SoVRMLInline::setChildData (SoNode * urldata)
Sets the child data. Can be used by the URL fetch callback.

  SoNode * SoVRMLInline::getChildData (void) const
Returns the child data (the scene loaded from the URL).

  void SoVRMLInline::setFetchURLCallBack (SoVRMLInlineFetchURLCB * f, void * closure) [static]
Sets the callback used to handle URL loading.

  void SoVRMLInline::setBoundingBoxVisibility (BboxVisibility b) [static]
Sets the bounding box visibility strategy.

  SoVRMLInline::BboxVisibility SoVRMLInline::getBoundingBoxVisibility (void) [static]
Returns the bounding box visibility strategy.

  void SoVRMLInline::setBoundingBoxColor (SbColor & color) [static]
Sets the color of the bounding box.

  SbColor & SoVRMLInline::getBoundingBoxColor (void) [static]
Returns the color of the bounding box.

  void SoVRMLInline::setReadAsSoFile (SbBool enable) [static]
Sets whether Inline nodes should be treated as a normal Inventor SoFile node.

  SbBool SoVRMLInline::getReadAsSoFile (void) [static]
Returns whether Inline nodes are read as SoFile nodes.

  void SoVRMLInline::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVRMLInline::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoVRMLInline::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVRMLInline::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoVRMLInline::getMatrix (SoGetMatrixAction * action) [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

  void SoVRMLInline::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoNode.

  void SoVRMLInline::search (SoSearchAction * action) [virtual]
Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
    SoSearchAction

Reimplemented from SoNode.

  void SoVRMLInline::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoVRMLInline::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

  SoChildList * SoVRMLInline::getChildren (void) const [virtual]
Returns list of children for this node.

Reimplemented from SoNode.

Author

Generated automatically by Doxygen for Coin from the source code.